{smcl}

{smcl}

{* Mar122012}{...}
{hline}
help for {hi:splinesBBK}{right:March 12th, 2012}
{right:by Luc Bissonnette}
{hline}


{title:Estimating expected value and quantile with cubic splines intrapolation (based on Bellemare et al, 2012)}

{p 8 16 2}
{cmdab:splinesBBK} [{it:newvarname}] {cmd:,}
{cmdab:qn:ame(}{it:string}{cmd:)} 
{cmdab:ql:ist(}{it:numlist}{cmd:)}
{cmdab:k:nots(}{it:varlist}{cmd:)} 
{cmdab:p:rob(}{it:numlist}{cmd:)} 
[
{cmdab:randd:draws(}{it:integer}{cmd:)}
{cmdab:randn:name(}{it:string}{cmd:)}
{cmdab:h:yman(}{it:integer}{cmd:)}  
{cmdab:eps:ilon(}{it:real}{cmd:)}
]
{p_end}


{p 4 8 2}
The first mandatory argument to the function is the name of variable (to be generated) containing the estimated expected value.
{p_end}

{p 4 8 2}
The mandatory option {cmd:qlist} must include a list of quantiles that will be estimated. Generated variables will have the name {cmd:qname} + 100*qlist (e.g. qname(estq) and qlist(0.25 0.5 0.75) will generate
three variables estq25 estq50 and estq75).
{p_end}

{p 4 8 2}
The knots and the value of the CDF at these knots are passed respectively with the options {cmd:knots} and {cmd:prob}.
{p_end}


{p 4 8 2}
The program allows to randomly draw from the estimated distribution. The user must set the desired number of draws using the optional argument {cmd:randdraws}. By default, the draws will be stored in variables named "ran_x" where x will be replace by a value between 1 and the number of draws. The prefix "ran_" can be modified with the argument {cmd:randname}.
{p_end}

{p 4 8 2}
Finally, the optional argument {cmd:hyman} allows to turn off the Hyman filter (no filter if hyman(0) is used). The other optional argument, {cmd:epsilon} determines
the precision used to numerically find the quantiles (default = 0.001).


{p_end}

{title:Description}

{p 4 8 2}
This function estimates a distribution using cubic splines interpolations, as presented by Bellemare et al. (JBES, 2012). The function can returns the expected value, specified quantiles, and random draws from the estimated distribution.
{p_end}


{title:Example: Simulated data}

{p 4 4 2}
Generating data from an empty dataset (you can click on each line to execute the commands).

	. {stata clear}
	. {stata set obs 1}	

	
{p 4 4 2}
First, we generate knots. 

	. {stata gen varknot1 = 0}
	. {stata gen varknot2 = 3}	   
	. {stata gen varknot3 = 5}	   
	. {stata gen varknot4 = 9}	   
	. {stata gen varknot5 = 10}

	
{p 4 4 2}
Then, we give some probability values at these knots. 	 
 
	. {stata gen varprob1 = 0.25}
	. {stata gen varprob2 = 0.35}	   
	. {stata gen varprob3 = 0.65}	   
	. {stata gen varprob4 = 0.90}	   
	. {stata gen varprob5 = 1.00}	   	

	
{p 4 4 2}	   
The core command is called as follows:	

	. {stata splinesBBK estexp, qname(estq) qlist(0.25 0.5 0.75) knots(varknot?) prob(varprob?) eps(0.01) randdraws(10)}

After this command, 15 new variables are available: 

	. {it:estexp} contains the estimated expected value; 
	. {it:estq25}, {it:estq50}, and {it:estq75} contain the 25th, 50th (median), and 75th percentiles; 
	. {it:ran_1 to ran_10} containing 10 randoms draws from the estimated distribution. 
	. {it:hyman} indicates which observations required the Hyman filter.



{title:Author}
{p 4 4 2}
Luc Bissonnette, CIRPEE, Universite Laval, Departement of Economics.{break}
L.Bissonnette@ecn.ulaval.ca{break}{p_end}

{hline}
